Index: LMDZ5/branches/testing/libf/dyn3d/advtrac.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/advtrac.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/dyn3d/advtrac.F90	(revision 2298)
@@ -9,5 +9,5 @@
   !            M.A Filiberti (04/2002)
   !
-  USE infotrac, ONLY: nqtot, iadv
+  USE infotrac, ONLY: nqtot, iadv,nqperes,ok_iso_verif
   USE control_mod, ONLY: iapp_tracvl, day_step
 
@@ -79,6 +79,6 @@
 
   IF(iadvtr.EQ.0) THEN
-     CALL initial0(ijp1llm,pbaruc)
-     CALL initial0(ijmllm,pbarvc)
+     pbaruc(:,:)=0
+     pbarvc(:,:)=0
   ENDIF
 
@@ -223,5 +223,11 @@
      !     Appel des sous programmes d'advection
      !-----------------------------------------------------------
-     do iq=1,nqtot
+
+     if (ok_iso_verif) then
+           write(*,*) 'advtrac 227'
+           call check_isotopes_seq(q,ip1jmp1,'advtrac 162')
+     endif !if (ok_iso_verif) then
+
+     do iq=1,nqperes
         !        call clock(t_initial)
         if(iadv(iq) == 0) cycle 
@@ -230,6 +236,9 @@
         !   ----------------------------------------------------------------
         if(iadv(iq).eq.10) THEN
-           call vlsplt(q(1,1,iq),2.,massem,wg,pbarug,pbarvg,dtvr)
-
+           ! CRisi: on fait passer tout q pour avoir acces aux fils
+           
+           !write(*,*) 'advtrac 239: iq,q(1721,19,:)=',iq,q(1721,19,:)     
+           call vlsplt(q,2.,massem,wg,pbarug,pbarvg,dtvr,iq)
+           
            !   ----------------------------------------------------------------
            !   Schema "pseudo amont" + test sur humidite specifique
@@ -238,6 +247,8 @@
         else if(iadv(iq).eq.14) then
            !
-           CALL vlspltqs( q(1,1,1), 2., massem, wg , &
-                pbarug,pbarvg,dtvr,p,pk,teta )
+           !write(*,*) 'advtrac 248: iq,q(1721,19,:)=',iq,q(1721,19,:)
+           CALL vlspltqs( q, 2., massem, wg , &
+                pbarug,pbarvg,dtvr,p,pk,teta,iq)
+           
            !   ----------------------------------------------------------------
            !   Schema de Frederic Hourdin
@@ -388,4 +399,8 @@
      end DO
 
+     if (ok_iso_verif) then
+           write(*,*) 'advtrac 402'
+           call check_isotopes_seq(q,ip1jmp1,'advtrac 397')
+     endif !if (ok_iso_verif) then
 
      !------------------------------------------------------------------
Index: LMDZ5/branches/testing/libf/dyn3d/caladvtrac.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/caladvtrac.F	(revision 2274)
+++ LMDZ5/branches/testing/libf/dyn3d/caladvtrac.F	(revision 2298)
@@ -53,5 +53,8 @@
       if (planet_type.eq."earth") then
 C initialisation
-        dq(:,:,1:2)=q(:,:,1:2)
+! CRisi: il faut gérer tous les traceurs si on veut pouvoir faire des
+! isotopes
+!        dq(:,:,1:2)=q(:,:,1:2)
+        dq(:,:,1:nqtot)=q(:,:,1:nqtot)
        
 c  test des valeurs minmax
@@ -81,6 +84,8 @@
            ENDDO
           ENDDO
-          
-          CALL qminimum( q, 2, finmasse )
+
+          !write(*,*) 'caladvtrac 87'
+          CALL qminimum( q, nqtot, finmasse )
+          !write(*,*) 'caladvtrac 89'
 
           CALL SCOPY   ( ip1jmp1*llm, masse, 1, finmasse,       1 )
@@ -92,5 +97,5 @@
           dtvrtrac = iapp_tracvl * dtvr
 c
-           DO iq = 1 , 2
+           DO iq = 1 , nqtot
             DO l = 1 , llm
              DO ij = 1,ip1jmp1
@@ -105,5 +110,5 @@
         if (planet_type.eq."earth") then
 ! Earth-specific treatment for the first 2 tracers (water)
-          dq(:,:,1:2)=0.
+          dq(:,:,1:nqtot)=0.
         endif ! of if (planet_type.eq."earth")
       ENDIF ! of IF( iapptrac.EQ.iapp_tracvl )
Index: LMDZ5/branches/testing/libf/dyn3d/check_isotopes.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/check_isotopes.F	(revision 2298)
+++ LMDZ5/branches/testing/libf/dyn3d/check_isotopes.F	(revision 2298)
@@ -0,0 +1,201 @@
+        subroutine check_isotopes_seq(q,ip1jmp1,err_msg)
+        USE infotrac
+        implicit none
+
+#include "dimensions.h"
+
+        ! inputs
+        integer ip1jmp1
+        real q(ip1jmp1,llm,nqtot)
+        character*(*) err_msg ! message d''erreur à afficher
+
+        ! locals
+        integer ixt,phase,k,i,iq,iiso,izone,ieau,iqeau
+        real xtractot,xiiso
+        real borne
+        real qmin
+        real errmax ! erreur maximale en absolu.
+        real errmaxrel ! erreur maximale en relatif autorisée
+        real deltaDmax,deltaDmin
+        real ridicule
+        parameter (borne=1e19)
+        parameter (errmax=1e-8)
+        parameter (errmaxrel=1e-3)
+        parameter (qmin=1e-11)
+        parameter (deltaDmax=200.0,deltaDmin=-999.9)
+        parameter (ridicule=1e-12)
+        real deltaD
+
+        if (ok_isotopes) then
+
+        write(*,*) 'check_isotopes 31: err_msg=',err_msg
+        ! verifier que rien n'est NaN
+        do ixt=1,ntraciso
+          do phase=1,nqo
+            iq=iqiso(ixt,phase)
+            do k=1,llm
+              DO i = 1,ip1jmp1
+                if ((q(i,k,iq).gt.-borne).and.
+     :            (q(i,k,iq).lt.borne)) then
+                else !if ((x(ixt,i,j).gt.-borne).and.
+                  write(*,*) 'erreur detectee par iso_verif_noNaN:'
+                  write(*,*) err_msg
+                  write(*,*) 'q,i,k,iq=',q(i,k,iq),i,k,iq
+                  write(*,*) 'borne=',borne
+                  stop
+                endif  !if ((x(ixt,i,j).gt.-borne).and.
+              enddo !DO i = 1,ip1jmp1
+            enddo !do k=1,llm
+          enddo !do phase=1,nqo
+        enddo !do ixt=1,ntraciso
+
+        !write(*,*) 'check_isotopes 52'
+        ! verifier que l'eau normale est OK
+        if (use_iso(1)) then
+          ixt=indnum_fn_num(1)
+          do phase=1,nqo
+            iq=iqiso(ixt,phase)
+            do k=1,llm
+            DO i = 1,ip1jmp1  
+              if ((abs(q(i,k,phase)-q(i,k,iq)).gt.errmax).and.
+     :          (abs((q(i,k,phase)-q(i,k,iq))/
+     :           max(max(abs(q(i,k,phase)),abs(q(i,k,iq))),1e-18))
+     :           .gt.errmaxrel)) then
+                  write(*,*) 'erreur detectee par iso_verif_egalite:'
+                  write(*,*) err_msg
+                  write(*,*) 'ixt,phase=',ixt,phase
+                  write(*,*) 'q,iq,i,k=',q(i,k,iq),iq,i,k
+                  write(*,*) 'q(i,k,phase)=',q(i,k,phase)
+                  stop
+              endif !if ((abs(q(i,k,phase)-q(i,k,iq)).gt.errmax).and.
+              ! bidouille pour éviter divergence:
+              q(i,k,iq)= q(i,k,phase) 
+            enddo ! DO i = 1,ip1jmp1
+            enddo !do k=1,llm
+          enddo ! do phase=1,nqo 
+        endif !if (use_iso(1)) then
+        
+        !write(*,*) 'check_isotopes 78'
+        ! verifier que HDO est raisonable
+        if (use_iso(2)) then
+          ixt=indnum_fn_num(2)
+          do phase=1,nqo
+            iq=iqiso(ixt,phase)
+            do k=1,llm
+            DO i = 1,ip1jmp1
+            if (q(i,k,iq).gt.qmin) then
+             deltaD=(q(i,k,iq)/q(i,k,phase)/tnat(2)-1)*1000
+             if ((deltaD.gt.deltaDmax).or.(deltaD.lt.deltaDmin)) then
+                  write(*,*) 'erreur detectee par iso_verif_aberrant:'
+                  write(*,*) err_msg
+                  write(*,*) 'ixt,phase=',ixt,phase
+                  write(*,*) 'q,iq,i,k,=',q(i,k,iq),iq,i,k
+                  write(*,*) 'q=',q(i,k,:)
+                  write(*,*) 'deltaD=',deltaD
+                  stop
+             endif !if ((deltaD.gt.deltaDmax).or.(deltaD.lt.deltaDmin)) then
+            endif !if (q(i,k,iq).gt.qmin) then
+            enddo !DO i = 1,ip1jmp1
+            enddo !do k=1,llm
+          enddo ! do phase=1,nqo 
+        endif !if (use_iso(2)) then
+
+        !write(*,*) 'check_isotopes 103'
+        ! verifier que O18 est raisonable
+        if (use_iso(3)) then
+          ixt=indnum_fn_num(3)
+          do phase=1,nqo
+            iq=iqiso(ixt,phase)
+            do k=1,llm
+            DO i = 1,ip1jmp1
+            if (q(i,k,iq).gt.qmin) then
+             deltaD=(q(i,k,iq)/q(i,k,phase)/tnat(3)-1)*1000
+             if ((deltaD.gt.deltaDmax).or.(deltaD.lt.deltaDmin)) then
+                  write(*,*) 'erreur detectee iso_verif_aberrant O18:'
+                  write(*,*) err_msg
+                  write(*,*) 'ixt,phase=',ixt,phase
+                  write(*,*) 'q,iq,i,k,=',q(i,k,phase),iq,i,k
+                  write(*,*) 'xt=',q(i,k,:)
+                  write(*,*) 'deltaO18=',deltaD
+                  stop
+             endif !if ((deltaD.gt.deltaDmax).or.(deltaD.lt.deltaDmin)) then
+            endif !if (q(i,k,iq).gt.qmin) then
+            enddo !DO i = 1,ip1jmp1
+            enddo !do k=1,llm
+          enddo ! do phase=1,nqo 
+        endif !if (use_iso(2)) then
+
+
+        !write(*,*) 'check_isotopes 129'
+        if (ok_isotrac) then
+
+          if (use_iso(2).and.use_iso(1)) then
+            do izone=1,ntraceurs_zone
+             ixt=index_trac(izone,indnum_fn_num(2))
+             ieau=index_trac(izone,indnum_fn_num(1))
+             do phase=1,nqo
+               iq=iqiso(ixt,phase)
+               iqeau=iqiso(ieau,phase)
+               do k=1,llm
+                DO i = 1,ip1jmp1
+                if (q(i,k,iq).gt.qmin) then
+                 deltaD=(q(i,k,iq)/q(i,k,iqeau)/tnat(2)-1)*1000
+                 if ((deltaD.gt.deltaDmax).or.
+     &                   (deltaD.lt.deltaDmin)) then
+                  write(*,*) 'erreur dans iso_verif_aberrant trac:'
+                  write(*,*) err_msg
+                  write(*,*) 'izone,phase=',izone,phase
+                  write(*,*) 'ixt,ieau=',ixt,ieau
+                  write(*,*) 'q,iq,i,k,=',q(i,k,iq),iq,i,k
+                  write(*,*) 'deltaD=',deltaD
+                  stop
+                 endif !if ((deltaD.gt.deltaDmax).or.
+                endif !if (q(i,k,iq).gt.qmin) then
+                enddo !DO i = 1,ip1jmp1
+                enddo  ! do k=1,llm
+              enddo ! do phase=1,nqo    
+            enddo !do izone=1,ntraceurs_zone
+          endif !if (use_iso(2).and.use_iso(1)) then
+
+          do iiso=1,niso
+           do phase=1,nqo
+              iq=iqiso(iiso,phase)
+              do k=1,llm
+                DO i = 1,ip1jmp1
+                   xtractot=0.0
+                   xiiso=q(i,k,iq)
+                   do izone=1,ntraceurs_zone
+                      iq=iqiso(index_trac(izone,iiso),phase)
+                      xtractot=xtractot+ q(i,k,iq)
+                   enddo !do izone=1,ntraceurs_zone
+                   if ((abs(xtractot-xiiso).gt.errmax).and.
+     :                  (abs(xtractot-xiiso)/
+     :                  max(max(abs(xtractot),abs(xiiso)),1e-18)
+     :                  .gt.errmaxrel)) then
+                  write(*,*) 'erreur detectee par iso_verif_traceurs:'
+                  write(*,*) err_msg
+                  write(*,*) 'iiso,phase=',iiso,phase
+                  write(*,*) 'i,k,=',i,k
+                  write(*,*) 'q(i,k,:)=',q(i,k,:)
+                  stop
+                 endif !if ((abs(q(i,k,phase)-q(i,k,iq)).gt.errmax).and.
+                  
+                 ! bidouille pour éviter divergence:
+                 if (abs(xtractot).gt.ridicule) then
+                   do izone=1,ntraceurs_zone
+                     ixt=index_trac(izone,iiso) 
+                     q(i,k,iq)=q(i,k,iq)/xtractot*xiiso
+                   enddo !do izone=1,ntraceurs_zone                
+                  endif !if ((abs(xtractot).gt.ridicule) then
+                enddo !DO i = 1,ip1jmp1
+              enddo !do k=1,llm
+           enddo !do phase=1,nqo
+          enddo !do iiso=1,niso
+
+        endif !if (ok_isotrac) then
+
+        endif ! if (ok_isotopes)
+        !write(*,*) 'check_isotopes 198'
+        
+        end
+
Index: LMDZ5/branches/testing/libf/dyn3d/conf_gcm.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/conf_gcm.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/dyn3d/conf_gcm.F90	(revision 2298)
@@ -46,5 +46,4 @@
   LOGICAL  fxyhypbb, ysinuss
   INTEGER i
-  LOGICAL use_filtre_fft
 
   !  -------------------------------------------------------------------
@@ -89,7 +88,7 @@
 
   !Config  Key  = prt_level
-  !Config  Desc = niveau d'impressions de débogage
+  !Config  Desc = niveau d'impressions de d\'ebogage
   !Config  Def  = 0
-  !Config  Help = Niveau d'impression pour le débogage
+  !Config  Help = Niveau d'impression pour le d\'ebogage
   !Config         (0 = minimum d'impression)
   prt_level = 0
@@ -733,5 +732,5 @@
      dzoomy = 0.2
      CALL getin('dzoomy',dzoomy)
-     call assert(dzoomy< 1, "conf_gcm: dzoomy must be < 1")
+     call assert(dzoomy < 1, "conf_gcm: dzoomy must be < 1")
 
      !Config  Key  = taux
@@ -810,23 +809,8 @@
      CALL getin('ok_dyn_ave',ok_dyn_ave) 
 
-     !Config  Key  = use_filtre_fft
-     !Config  Desc = flag d'activation des FFT pour le filtre
-     !Config  Def  = false
-     !Config  Help = permet d'activer l'utilisation des FFT pour effectuer
-     !Config         le filtrage aux poles.
-     ! Le filtre fft n'est pas implemente dans dyn3d 
-     use_filtre_fft=.FALSE.
-     CALL getin('use_filtre_fft',use_filtre_fft)
-
-     IF (use_filtre_fft) THEN
-        write(lunout,*)'STOP !!!'
-        write(lunout,*)'use_filtre_fft n est pas implemente dans dyn3d'
-        STOP 1
-     ENDIF
-
      !Config key = ok_strato
      !Config  Desc = activation de la version strato
      !Config  Def  = .FALSE.
-     !Config  Help = active la version stratosphérique de LMDZ de F. Lott
+     !Config  Help = active la version stratosph\'erique de LMDZ de F. Lott
 
      ok_strato=.FALSE.
Index: LMDZ5/branches/testing/libf/dyn3d/dynetat0.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/dynetat0.F	(revision 2274)
+++ LMDZ5/branches/testing/libf/dyn3d/dynetat0.F	(revision 2298)
@@ -297,4 +297,19 @@
            write(lunout,*)"          Il est donc initialise a zero"
            q(:,:,:,iq)=0.
+
+           ! CRisi: pour les isotopes, on peut faire init théorique
+           ! distill de Rayleigh très simplifiée
+           if (ok_isotopes) then
+              if ((iso_num(iq).gt.0).and.(zone_num(iq).eq.0)) then
+                q(:,:,:,iq)=q(:,:,:,iqpere(iq))                         
+     &                   *tnat(iso_num(iq))                             
+     &                   *(q(:,:,:,iqpere(iq))/30.e-3)                  
+     &                   **(alpha_ideal(iso_num(iq))-1)
+              endif
+              if ((iso_num(iq).gt.0).and.(zone_num(iq).eq.1)) then
+                  q(:,:,:,iq)=q(:,:,:,iqiso(iso_indnum(iq),
+     &                   phase_num(iq)))
+              endif  
+           endif !if (ok_isotopes) then 
         ELSE
            ierr = NF90_GET_VAR(nid, nvarid, q(:,:,:,iq))
Index: LMDZ5/branches/testing/libf/dyn3d/fluxstokenc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/fluxstokenc.F	(revision 2274)
+++ LMDZ5/branches/testing/libf/dyn3d/fluxstokenc.F	(revision 2298)
@@ -83,8 +83,8 @@
 
       IF(iadvtr.EQ.0) THEN
-         CALL initial0(ijp1llm,phic)
-         CALL initial0(ijp1llm,tetac)
-         CALL initial0(ijp1llm,pbaruc)
-         CALL initial0(ijmllm,pbarvc)
+         phic(:,:)=0
+         tetac(:,:)=0
+         pbaruc(:,:)=0
+         pbarvc(:,:)=0
       ENDIF
 
Index: LMDZ5/branches/testing/libf/dyn3d/gcm.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/gcm.F90	(revision 2298)
+++ LMDZ5/branches/testing/libf/dyn3d/gcm.F90	(revision 2298)
@@ -0,0 +1,499 @@
+!
+! $Id$
+!
+!
+!
+PROGRAM gcm
+
+#ifdef CPP_IOIPSL
+  USE IOIPSL
+#else
+  ! if not using IOIPSL, we still need to use (a local version of) getin
+  USE ioipsl_getincom
+#endif
+
+
+#ifdef CPP_XIOS
+  ! ug Pour les sorties XIOS
+  USE wxios
+#endif
+
+  USE filtreg_mod
+  USE infotrac
+  USE control_mod
+
+#ifdef INCA
+  ! Only INCA needs these informations (from the Earth's physics)
+  USE indice_sol_mod
+  USE mod_phys_lmdz_para, ONLY : klon_mpi_para_nb
+#endif
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  ! FH 2008/05/09 On elimine toutes les clefs physiques dans la dynamique
+  ! A nettoyer. On ne veut qu'une ou deux routines d'interface 
+  ! dynamique -> physique pour l'initialisation
+#ifdef CPP_PHYS
+  !      USE dimphy
+  !      USE comgeomphy
+#endif
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  IMPLICIT NONE
+
+  !      ......   Version  du 10/01/98    ..........
+
+  !             avec  coordonnees  verticales hybrides 
+  !   avec nouveaux operat. dissipation * ( gradiv2,divgrad2,nxgraro2 )
+
+  !=======================================================================
+  !
+  !   Auteur:  P. Le Van /L. Fairhead/F.Hourdin
+  !   -------
+  !
+  !   Objet:
+  !   ------
+  !
+  !   GCM LMD nouvelle grille
+  !
+  !=======================================================================
+  !
+  !  ... Dans inigeom , nouveaux calculs pour les elongations  cu , cv
+  !      et possibilite d'appeler une fonction f(y)  a derivee tangente
+  !      hyperbolique a la  place de la fonction a derivee sinusoidale.
+  !  ... Possibilite de choisir le schema pour l'advection de
+  !        q  , en modifiant iadv dans traceur.def  (MAF,10/02) .
+  !
+  !      Pour Van-Leer + Vapeur d'eau saturee, iadv(1)=4. (F.Codron,10/99)
+  !      Pour Van-Leer iadv=10
+  !
+  !-----------------------------------------------------------------------
+  !   Declarations:
+  !   -------------
+
+  include "dimensions.h"
+  include "paramet.h"
+  include "comconst.h"
+  include "comdissnew.h"
+  include "comvert.h"
+  include "comgeom.h"
+  include "logic.h"
+  include "temps.h"
+!!!!!!!!!!!include "control.h"
+  include "ener.h"
+  include "description.h"
+  include "serre.h"
+  !include "com_io_dyn.h"
+  include "iniprint.h"
+  include "tracstoke.h"
+#ifdef INCA
+  ! Only INCA needs these informations (from the Earth's physics)
+  !include "indicesol.h"
+#endif
+
+  REAL zdtvr
+
+  !   variables dynamiques
+  REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
+  REAL teta(ip1jmp1,llm)                 ! temperature potentielle 
+  REAL, ALLOCATABLE, DIMENSION(:,:,:):: q! champs advectes
+  REAL ps(ip1jmp1)                       ! pression  au sol
+  REAL p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
+  REAL masse(ip1jmp1,llm)                ! masse d'air
+  REAL phis(ip1jmp1)                     ! geopotentiel au sol
+  REAL phi(ip1jmp1,llm)                  ! geopotentiel
+  REAL w(ip1jmp1,llm)                    ! vitesse verticale
+
+  ! variables dynamiques intermediaire pour le transport
+
+  !   variables pour le fichier histoire
+  REAL dtav      ! intervalle de temps elementaire
+
+  REAL time_0
+
+  LOGICAL lafin
+  INTEGER ij,iq,l,i,j
+
+
+  real time_step, t_wrt, t_ops
+
+  LOGICAL first
+
+  !      LOGICAL call_iniphys
+  !      data call_iniphys/.true./
+
+  !+jld variables test conservation energie
+  !      REAL ecin(ip1jmp1,llm),ecin0(ip1jmp1,llm)
+  !     Tendance de la temp. potentiel d (theta)/ d t due a la 
+  !     tansformation d'energie cinetique en energie thermique
+  !     cree par la dissipation
+  REAL dhecdt(ip1jmp1,llm)
+  !      REAL vcont(ip1jm,llm),ucont(ip1jmp1,llm)
+  !      REAL      d_h_vcol, d_qt, d_qw, d_ql, d_ec
+  CHARACTER (len=15) :: ztit
+  !-jld 
+
+
+  character (len=80) :: dynhist_file, dynhistave_file
+  character (len=20) :: modname
+  character (len=80) :: abort_message
+  ! locales pour gestion du temps
+  INTEGER :: an, mois, jour
+  REAL :: heure
+  logical use_filtre_fft
+
+  !-----------------------------------------------------------------------
+  !   Initialisations:
+  !   ----------------
+
+  abort_message = 'last timestep reached'
+  modname = 'gcm'
+  descript = 'Run GCM LMDZ'
+  lafin    = .FALSE.
+  dynhist_file = 'dyn_hist.nc'
+  dynhistave_file = 'dyn_hist_ave.nc'
+
+
+
+  !----------------------------------------------------------------------
+  !  lecture des fichiers gcm.def ou run.def
+  !  ---------------------------------------
+  !
+  CALL conf_gcm( 99, .TRUE.)
+
+  if (mod(iphysiq, iperiod) /= 0) call abort_gcm("conf_gcm", &
+       "iphysiq must be a multiple of iperiod", 1)
+
+  use_filtre_fft=.FALSE.
+  CALL getin('use_filtre_fft',use_filtre_fft)
+  IF (use_filtre_fft) call abort_gcm('FFT filter is not available in the ' &
+          // 'sequential version of the dynamics.', 1)
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  ! Initialisation de XIOS
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+#ifdef CPP_XIOS
+  CALL wxios_init("LMDZ")
+#endif
+
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  ! FH 2008/05/02
+  ! A nettoyer. On ne veut qu'une ou deux routines d'interface 
+  ! dynamique -> physique pour l'initialisation
+#ifdef CPP_PHYS
+  CALL Init_Phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
+  !      call InitComgeomphy ! now done in iniphysiq
+#endif
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  !-----------------------------------------------------------------------
+  !   Choix du calendrier
+  !   -------------------
+
+  !      calend = 'earth_365d'
+
+#ifdef CPP_IOIPSL
+  if (calend == 'earth_360d') then
+     call ioconf_calendar('360d')
+     write(lunout,*)'CALENDRIER CHOISI: Terrestre a 360 jours/an'
+  else if (calend == 'earth_365d') then
+     call ioconf_calendar('noleap')
+     write(lunout,*)'CALENDRIER CHOISI: Terrestre a 365 jours/an'
+  else if (calend == 'gregorian') then
+     call ioconf_calendar('gregorian')
+     write(lunout,*)'CALENDRIER CHOISI: Terrestre bissextile'
+  else
+     abort_message = 'Mauvais choix de calendrier'
+     call abort_gcm(modname,abort_message,1)
+  endif
+#endif
+  !-----------------------------------------------------------------------
+
+  IF (type_trac == 'inca') THEN
+#ifdef INCA
+     call init_const_lmdz(nbtr,anneeref,dayref,iphysiq,day_step,nday,  &
+          nbsrf, is_oce,is_sic,is_ter,is_lic)
+     call init_inca_para(iim,jjm+1,klon,1,klon_mpi_para_nb,0)
+#endif
+  END IF
+  !
+  !
+  !------------------------------------
+  !   Initialisation partie parallele
+  !------------------------------------
+
+  !
+  !
+  !-----------------------------------------------------------------------
+  !   Initialisation des traceurs
+  !   ---------------------------
+  !  Choix du nombre de traceurs et du schema pour l'advection
+  !  dans fichier traceur.def, par default ou via INCA
+  call infotrac_init
+
+  ! Allocation de la tableau q : champs advectes   
+  allocate(q(ip1jmp1,llm,nqtot))
+
+  !-----------------------------------------------------------------------
+  !   Lecture de l'etat initial :
+  !   ---------------------------
+
+  !  lecture du fichier start.nc
+  if (read_start) then
+     ! we still need to run iniacademic to initialize some
+     ! constants & fields, if we run the 'newtonian' or 'SW' cases:
+     if (iflag_phys.ne.1) then
+        CALL iniacademic(vcov,ucov,teta,q,masse,ps,phis,time_0)
+     endif
+
+     !        if (planet_type.eq."earth") then
+     ! Load an Earth-format start file
+     CALL dynetat0("start.nc",vcov,ucov, &
+          teta,q,masse,ps,phis, time_0)
+     !        endif ! of if (planet_type.eq."earth")
+
+     !       write(73,*) 'ucov',ucov
+     !       write(74,*) 'vcov',vcov
+     !       write(75,*) 'teta',teta
+     !       write(76,*) 'ps',ps
+     !       write(77,*) 'q',q
+
+  endif ! of if (read_start)
+
+  IF (type_trac == 'inca') THEN
+#ifdef INCA
+     call init_inca_dim(klon,llm,iim,jjm, &
+          rlonu,rlatu,rlonv,rlatv)
+#endif
+  END IF
+
+
+  ! le cas echeant, creation d un etat initial
+  IF (prt_level > 9) WRITE(lunout,*) &
+       'GCM: AVANT iniacademic AVANT AVANT AVANT AVANT'
+  if (.not.read_start) then
+     CALL iniacademic(vcov,ucov,teta,q,masse,ps,phis,time_0)
+  endif
+
+
+  !-----------------------------------------------------------------------
+  !   Lecture des parametres de controle pour la simulation :
+  !   -------------------------------------------------------
+  !  on recalcule eventuellement le pas de temps
+
+  IF(MOD(day_step,iperiod).NE.0) THEN
+     abort_message =  &
+          'Il faut choisir un nb de pas par jour multiple de iperiod'
+     call abort_gcm(modname,abort_message,1)
+  ENDIF
+
+  IF(MOD(day_step,iphysiq).NE.0) THEN
+     abort_message =  &
+          'Il faut choisir un nb de pas par jour multiple de iphysiq'
+     call abort_gcm(modname,abort_message,1)
+  ENDIF
+
+  zdtvr    = daysec/REAL(day_step)
+  IF(dtvr.NE.zdtvr) THEN
+     WRITE(lunout,*) &
+          'WARNING!!! changement de pas de temps',dtvr,'>',zdtvr
+  ENDIF
+
+  !
+  ! on remet le calendrier \`a zero si demande
+  !
+  IF (start_time /= starttime) then
+     WRITE(lunout,*)' GCM: Attention l''heure de depart lue dans le' &
+          ,' fichier restart ne correspond pas a celle lue dans le run.def'
+     IF (raz_date == 1) then
+        WRITE(lunout,*)'Je prends l''heure lue dans run.def'
+        start_time = starttime
+     ELSE
+        call abort_gcm("gcm", "'Je m''arrete'", 1)
+     ENDIF
+  ENDIF
+  IF (raz_date == 1) THEN
+     annee_ref = anneeref
+     day_ref = dayref
+     day_ini = dayref
+     itau_dyn = 0
+     itau_phy = 0
+     time_0 = 0.
+     write(lunout,*) &
+          'GCM: On reinitialise a la date lue dans gcm.def'
+  ELSE IF (annee_ref .ne. anneeref .or. day_ref .ne. dayref) THEN
+     write(lunout,*) &
+          'GCM: Attention les dates initiales lues dans le fichier'
+     write(lunout,*) &
+          ' restart ne correspondent pas a celles lues dans '
+     write(lunout,*)' gcm.def'
+     write(lunout,*)' annee_ref=',annee_ref," anneeref=",anneeref
+     write(lunout,*)' day_ref=',day_ref," dayref=",dayref
+     write(lunout,*)' Pas de remise a zero'
+  ENDIF
+
+  !      if (annee_ref .ne. anneeref .or. day_ref .ne. dayref) then
+  !        write(lunout,*)
+  !     .  'GCM: Attention les dates initiales lues dans le fichier'
+  !        write(lunout,*)
+  !     .  ' restart ne correspondent pas a celles lues dans '
+  !        write(lunout,*)' gcm.def'
+  !        write(lunout,*)' annee_ref=',annee_ref," anneeref=",anneeref
+  !        write(lunout,*)' day_ref=',day_ref," dayref=",dayref
+  !        if (raz_date .ne. 1) then
+  !          write(lunout,*)
+  !     .    'GCM: On garde les dates du fichier restart'
+  !        else
+  !          annee_ref = anneeref
+  !          day_ref = dayref
+  !          day_ini = dayref
+  !          itau_dyn = 0
+  !          itau_phy = 0
+  !          time_0 = 0.
+  !          write(lunout,*)
+  !     .   'GCM: On reinitialise a la date lue dans gcm.def'
+  !        endif
+  !      ELSE
+  !        raz_date = 0
+  !      endif
+
+#ifdef CPP_IOIPSL
+  mois = 1
+  heure = 0.
+  call ymds2ju(annee_ref, mois, day_ref, heure, jD_ref)
+  jH_ref = jD_ref - int(jD_ref)
+  jD_ref = int(jD_ref)
+
+  call ioconf_startdate(INT(jD_ref), jH_ref)
+
+  write(lunout,*)'DEBUG'
+  write(lunout,*)'annee_ref, mois, day_ref, heure, jD_ref'
+  write(lunout,*)annee_ref, mois, day_ref, heure, jD_ref
+  call ju2ymds(jD_ref+jH_ref,an, mois, jour, heure)
+  write(lunout,*)'jD_ref+jH_ref,an, mois, jour, heure'
+  write(lunout,*)jD_ref+jH_ref,an, mois, jour, heure
+#else
+  ! Ehouarn: we still need to define JD_ref and JH_ref
+  ! and since we don't know how many days there are in a year
+  ! we set JD_ref to 0 (this should be improved ...)
+  jD_ref=0
+  jH_ref=0
+#endif
+
+
+  if (iflag_phys.eq.1) then
+     ! these initialisations have already been done (via iniacademic)
+     ! if running in SW or Newtonian mode
+     !-----------------------------------------------------------------------
+     !   Initialisation des constantes dynamiques :
+     !   ------------------------------------------
+     dtvr = zdtvr
+     CALL iniconst
+
+     !-----------------------------------------------------------------------
+     !   Initialisation de la geometrie :
+     !   --------------------------------
+     CALL inigeom
+
+     !-----------------------------------------------------------------------
+     !   Initialisation du filtre :
+     !   --------------------------
+     CALL inifilr
+  endif ! of if (iflag_phys.eq.1)
+  !
+  !-----------------------------------------------------------------------
+  !   Initialisation de la dissipation :
+  !   ----------------------------------
+
+  CALL inidissip( lstardis, nitergdiv, nitergrot, niterh   , &
+       tetagdiv, tetagrot , tetatemp, vert_prof_dissip)
+
+  !-----------------------------------------------------------------------
+  !   Initialisation de la physique :
+  !   -------------------------------
+
+  IF ((iflag_phys==1).or.(iflag_phys>=100)) THEN
+     ! Physics:
+#ifdef CPP_PHYS
+     CALL iniphysiq(iim,jjm,llm,daysec,day_ini,dtphys/nsplit_phys, &
+          rlatu,rlonv,aire,cu,cv,rad,g,r,cpp, &
+          iflag_phys)
+#endif
+  ENDIF ! of IF ((iflag_phys==1).or.(iflag_phys>=100))
+
+  !  numero de stockage pour les fichiers de redemarrage:
+
+  !-----------------------------------------------------------------------
+  !   Initialisation des I/O :
+  !   ------------------------
+
+
+  if (nday>=0) then
+     day_end = day_ini + nday
+  else
+     day_end = day_ini - nday/day_step
+  endif
+  WRITE(lunout,300)day_ini,day_end
+300 FORMAT('1'/,15x,'run du jour',i7,2x,'au jour',i7//)
+
+#ifdef CPP_IOIPSL
+  call ju2ymds(jD_ref + day_ini - day_ref, an, mois, jour, heure)
+  write (lunout,301)jour, mois, an
+  call ju2ymds(jD_ref + day_end - day_ref, an, mois, jour, heure)
+  write (lunout,302)jour, mois, an
+301 FORMAT('1'/,15x,'run du ', i2,'/',i2,'/',i4)
+302 FORMAT('1'/,15x,'    au ', i2,'/',i2,'/',i4)
+#endif
+
+  !      if (planet_type.eq."earth") then
+  ! Write an Earth-format restart file
+
+  CALL dynredem0("restart.nc", day_end, phis)
+  !      endif
+
+  ecripar = .TRUE.
+
+#ifdef CPP_IOIPSL
+  time_step = zdtvr
+  if (ok_dyn_ins) then
+     ! initialize output file for instantaneous outputs
+     ! t_ops = iecri * daysec ! do operations every t_ops
+     t_ops =((1.0*iecri)/day_step) * daysec  
+     t_wrt = daysec ! iecri * daysec ! write output every t_wrt
+     CALL inithist(day_ref,annee_ref,time_step, &
+          t_ops,t_wrt)
+  endif
+
+  IF (ok_dyn_ave) THEN 
+     ! initialize output file for averaged outputs
+     t_ops = iperiod * time_step ! do operations every t_ops
+     t_wrt = periodav * daysec   ! write output every t_wrt
+     CALL initdynav(day_ref,annee_ref,time_step, &
+          t_ops,t_wrt)
+  END IF
+  dtav = iperiod*dtvr/daysec
+#endif
+  ! #endif of #ifdef CPP_IOIPSL
+
+  !  Choix des frequences de stokage pour le offline
+  !      istdyn=day_step/4     ! stockage toutes les 6h=1jour/4
+  !      istdyn=day_step/12     ! stockage toutes les 2h=1jour/12
+  istdyn=day_step/4     ! stockage toutes les 6h=1jour/12
+  istphy=istdyn/iphysiq     
+
+
+  !
+  !-----------------------------------------------------------------------
+  !   Integration temporelle du modele :
+  !   ----------------------------------
+
+  !       write(78,*) 'ucov',ucov
+  !       write(78,*) 'vcov',vcov
+  !       write(78,*) 'teta',teta
+  !       write(78,*) 'ps',ps
+  !       write(78,*) 'q',q
+
+
+  CALL leapfrog(ucov,vcov,teta,ps,masse,phis,q,time_0)
+
+END PROGRAM gcm
